unit Subex16;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Wndsub16;

type
  Tmain = class(TForm)
    Choose: TRadioGroup;
    Button1: TButton;
    ss: TButton;
    before: TRadioButton;
    after: TRadioButton;
    Label2: TLabel;
    Subclass161: TSubclass16;
    MsgLB: TListBox;
    MsgLabel: TLabel;
    Label1: TLabel;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure ChooseClick(Sender: TObject);
    procedure ssClick(Sender: TObject);
    procedure afterClick(Sender: TObject);
    procedure beforeClick(Sender: TObject);
    procedure Subclass161MsgReceived(var Msg, wParam: Word;
      var lParam: Longint; var CallDefWndProc: Boolean);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  main: Tmain;

implementation

{$R *.DFM}

procedure Tmain.Button1Click(Sender: TObject);
var Wnd: hWnd;
begin
  Wnd := FindWindow('TAppBuilder',NIL); {Get handle of Delphi's main window }
  if (Wnd = 0) then
    Messagebox(handle,'This 16-bit demo uses the actual Delphi interface, Delphi window not found!','Error',mb_taskmodal)
  else
    AppendMenu(GetSubMenu(GetMenu(Wnd),1), {menu handle of Delphi}
               MF_STRING,    {Just by string }
               1234,        {unique menu ID }
               'My Item!'); {Item to add }


end;

procedure Tmain.ChooseClick(Sender: TObject);
begin
  ss.enabled := true;
  if (choose.itemindex = 0) then
    Messagebox(handle,'Click Start if it''s not already!'#10'Try to click on a menu item of Delphi.  '+
                'If rmBeforeDefProc is checked, then the menu click will never get passed.','Note',mb_taskmodal)
  else
  if (choose.itemindex = 1) then
    Messagebox(handle,'Click Start if it''s not already!'#10'Click on any menu item of Delphi.  If rmBeforeDefProc is '+
                'checked, any item you click will cause the File|Open item to be clicked because we '+
                'change the value of the wParam to the File|Open menu id.','Note',mb_taskmodal)
  else
  if (choose.itemindex = 2) then
    Messagebox(handle,'Click Start if it''s not already!'#10'Click on the Append Menu button.  Look under the Edit| sub menu.'+
                ' It added a new item. Now try clicking on that item, it will note to you that your item is clicked.',
                'Note',mb_taskmodal);
  if (choose.itemindex = 3) then begin
    Messagebox(handle,'Click Start if it''s not already!'#10'Watch the listbox trace the messages, note the difference in '+
                'messages between the rmBeforeDefProc option and the rmAfterDefProc option.','Note',mb_taskmodal);
    main.Clientheight := 330;
    MsgLB.clear;
  end
  else
    main.clientheight := 170;
end;

procedure Tmain.ssClick(Sender: TObject);
var Wnd: hWnd;
begin
  with Subclass161 do begin
    Wnd := FindWindow('TAppBuilder',NIL); {locate Delphi window }
    if (Wnd = 0) then
      Messagebox(handle,'This 16-bit demo uses the actual Delphi interface, Delphi window not found!','Error',mb_taskmodal)
    else
    begin
      WindowHandle := Wnd;
      start := NOT(start);           {start or stop the subclass }
      if (start) then begin
        before.enabled := false;
        after.enabled := false;
        ss.caption := 'Stop!';
      end
      else
      begin
        before.enabled := true;
        after.enabled := true;
        ss.caption := 'Start!';
      end;
    end;
  end;
end;

procedure Tmain.afterClick(Sender: TObject);
begin
  Subclass161.ReceiveMessages := rmAfterDefProc;
end;

procedure Tmain.beforeClick(Sender: TObject);
begin
  Subclass161.ReceiveMessages := rmBeforeDefProc;
end;

procedure Tmain.Subclass161MsgReceived(var Msg, wParam: Word;
  var lParam: Longint; var CallDefWndProc: Boolean);
var menu,
    sub_menu,
    item_id: integer;
    MsgStr: string;
begin
  if (choose.itemindex = 0) then begin
    if (msg = WM_COMMAND)and(lParam = 0) then   {if it's a menu message }
      CallDefWndProc := FALSE;                  {Indicate to NOT call default window procedure }
  end
  else
  if (choose.itemindex = 1) then begin
    if (msg = WM_COMMAND)and(lParam=0) then begin   {if it's a menu message }
      menu := GetMenu(Subclass161.WindowHandle); {Get menu handle of window }
      sub_menu := GetSubMenu(menu,0);               {get handle of the File sub menu }
      item_id := GetMenuItemId(sub_menu,1);         {get handle of the File|Open ID }
      wParam := item_id;                            {change wParam to Open ID }
    end;
  end
  else
  if (choose.itemindex = 2) then begin
    if (msg = WM_COMMAND)and(lParam = 0) then       {if it's a menu message }
      if (wParam = 1234) then                       {if wParam is YOUR menu ID }
        Messagebox(handle,'Your item was clicked!','SUCCESS!',mb_taskmodal);
  end
  else
  if (choose.itemindex = 3) then begin
    MsgStr := Subclass161.MsgToStr(msg);                            {Using the MsgToStr method }
    if MsgStr = 'Unknown' then                                 {if it's an unknown message, then }
      MsgStr := Concat('WM_USER + ',inttohex(msg-WM_USER,4));  {get it's hex value and add it }
    MsgLB.items.add(MsgStr);
    MsgLabel.caption := MsgStr;
  end;
end;

procedure Tmain.Button3Click(Sender: TObject);
begin
  MsgLB.clear;
end;

end.
